<< problem 116 - Red, green or blue tiles | Pandigital prime sets - problem 118 >> |

# Problem 117: Red, green, and blue tiles

(see projecteuler.net/problem=117)

Using a combination of black square tiles and oblong tiles chosen from: red tiles measuring two units, green tiles measuring three units, and blue tiles measuring four units, it is possible to tile a row measuring five units in length in exactly fifteen different ways.

How many ways can a row measuring fifty units in length be tiled?

NOTE: This is related to Problem 116.

# Algorithm

... almost the same as problem 115 !

Actually the code is even shorter - the `for`

-loop in `count`

runs from 1 to 4 (1 = black, 2 = red, 3 = green, 4 = blue).

There are no "gaps" between tiles because I treat black tiles the same way like any other tile.

These numbers are also called "Generalized Fibonacci numbers", and the special case for this problem is called Tetranacci numbers.

## Modifications by HackerRank

As always, Hackerrank's input is ridiculously high and my poor C++ data types can't handle such numbers.

[TODO] find closed formula

# My code

… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too.

The code contains `#ifdef`

s to switch between the original problem and the Hackerrank version.

Enable `#ifdef ORIGINAL`

to produce the result for the original problem (default setting for most problems).

#include <iostream>
#include <vector>
#define ORIGINAL
// memoized solutions

const long long Unknown = -1;
std::vector<long long> solutions;
// find result for row with a certain length

unsigned long long count(unsigned long long space)
{
// finished ?
if (space == 0)
return 1;
// already know the answer ?
if (solutions[space] != Unknown)
return solutions[space];
// insert red blocks at the current position with all possible spaces
unsigned long long result = 0;
for (unsigned long long block = 1; block <= 4 && block <= space; block++)
{
// how much is left after inserting ?
auto next = space - block;
// count all combinations
result += count(next);
}
// memoize result
solutions[space] = result;
return result;
}
int main()
{
unsigned int tests;
std::cin >> tests;
while (tests--)
{
// what number should be exceeded ?
unsigned long long limit = 50;
std::cin >> limit;
// cached results
solutions.clear();
solutions.resize(limit+1, Unknown);
auto result = count(limit);
#ifndef ORIGINAL
result %= 1000000007; // Hackerrank asks for "small" results
#endif
std::cout << result << std::endl;
}
return 0;
}

This solution contains 12 empty lines, 10 comments and 5 preprocessor commands.

# Interactive test

You can submit your own input to my program and it will be instantly processed at my server:

This is equivalent to`echo "1 5" | ./117`

Output:

*Note:* the original problem's input `50`

__cannot__ be entered

because just copying results is a soft skill reserved for idiots.

*(this interactive test is still under development, computations will be aborted after one second)*

# Benchmark

The correct solution to the original Project Euler problem was found in less than 0.01 seconds on a Intel® Core™ i7-2600K CPU @ 3.40GHz.

(compiled for x86_64 / Linux, GCC flags: `-O3 -march=native -fno-exceptions -fno-rtti -std=c++11 -DORIGINAL`

)

See here for a comparison of all solutions.

**Note:** interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without `-DORIGINAL`

.

# Changelog

May 18, 2017 submitted solution

May 18, 2017 added comments

# Hackerrank

see https://www.hackerrank.com/contests/projecteuler/challenges/euler117

My code solves **1** out of **6** test cases (score: **0%**)

I failed **0** test cases due to wrong answers and **5** because of timeouts

# Difficulty

Project Euler ranks this problem at **35%** (out of 100%).

Hackerrank describes this problem as **easy**.

*Note:*

Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.

In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is never an option.

# Links

projecteuler.net/thread=117 - **the** best forum on the subject (*note:* you have to submit the correct solution first)

Code in various languages:

Python: www.mathblog.dk/project-euler-118-sets-prime-elements/ (written by Kristian Edlund)

Java: github.com/nayuki/Project-Euler-solutions/blob/master/java/p118.java (written by Nayuki)

Scala: github.com/samskivert/euler-scala/blob/master/Euler118.scala (written by Michael Bayne)

# Heatmap

green problems solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too.

yellow problems score less than 100% at Hackerrank (but still solve the original problem).

gray problems are already solved but I haven't published my solution yet.

blue problems are solved and there wasn't a Hackerrank version of it at the time I solved it or I didn't care about it because it differed too much.

*Please click on a problem's number to open my solution to that problem:*

1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |

26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |

51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |

76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |

101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |

126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |

151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |

176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |

201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |

226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |

My username at Project Euler is

**stephanbrumme**while it's stbrumme at Hackerrank.

<< problem 116 - Red, green or blue tiles | Pandigital prime sets - problem 118 >> |